﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Cycm
{
    static class ComHelper
    {
        public static void Register(string dllName, Guid clsid)
        {
            var ret = registerComDll(dllName, clsid);
            if (ret >= 0x80000000)
            {
                //Marshal.ThrowExceptionForHR(unchecked((int)ret));
                throw new Exception("RegisterComDll failed: " + ret.ToString("x"));
            }
        }

        public static void Register(string dllName, Type comClass)
        {
            // Not supported
            // Register("Native2008.dll", typeof(TestClass).GUID);

            var guidAttr = (GuidAttribute)Attribute.GetCustomAttribute(comClass, typeof(GuidAttribute));
            Register(dllName, new Guid(guidAttr.Value));
        }

        private static Func<string, Guid, uint> registerComDll = GetRegisterComDll();

        private static Func<string, Guid, uint> GetRegisterComDll()
        {
            var interopServices = Assembly.Load("Microsoft.Phone.InteropServices, Version=7.0.0.0, Culture=neutral, PublicKeyToken=24eec0d8c86cda1e");
            var comBridgeType = interopServices.GetType("Microsoft.Phone.InteropServices.ComBridge");
            return (Func<string, Guid, uint>)Delegate.CreateDelegate(typeof(Func<string, Guid, uint>), comBridgeType, "RegisterComDll");
        }
    }
}
